


CODE SEGMENT
ASSUME CS:CODE,DS:CODE,ES:CODE,SS:CODE
ORG 0100H
START:
         JMP INIT
         OLDCSIP DD ?
         TEMP DB 00H
         HR DB 00H
         MN DB 00H
         S1 DB 00H

USER:
         PUSH AX
         PUSH CX
         PUSH DX
         PUSH BX

         MOV AH,00H        ;TO INITIALISE TEXT MODE
         MOV AL,03H        ;TO INITIALISE GRAPHICS MODE
         INT 10H

         MOV AH,02H
         MOV BH,00H
         MOV DH,10         ;TO SHIFT X COORDINATE TO RIGHT
         MOV DL,50         ;TO SHIFT Y COORDINATE TO RIGHT
         INT 10H

         MOV AH,02H        ;TO GET TIME FROM CMOS
         INT 1AH

         MOV HR,CH
         MOV MN,CL
         MOV S1,DH

         MOV AL,HR
         CALL DISPLAY

         MOV AH,02H
         MOV DL,':'
         INT 21H


         MOV AL,MN
         CALL DISPLAY

         MOV AH,02H
         MOV DL,':'
         INT 21H

         MOV AL,S1
         CALL DISPLAY


         POP BX
         POP DX
         POP CX
         POP AX

         JMP CS:OLDCSIP

   INIT:
         CLD
         MOV AH,35H        ;TO GET VECTOR ADDR OF INTERRUPT WE WANT TO STEAL
         MOV AL,00H
         INT 21H

         MOV WORD PTR[OLDCSIP],BX
         MOV WORD PTR[OLDCSIP+2],ES

         MOV AH,25H         ;TO SET VECTOR ADDRESS
         MOV AL,00H
         MOV DX,OFFSET[USER]
         INT 21H

         MOV AH,31H         ;MAKE PROG RESIDENT IN MEMORY
         MOV DX,OFFSET INIT
         INT 21H

         STI

         DISPLAY PROC NEAR     ;DISPLAY PROCEDURE
         MOV TEMP,AL
         AND HR,0F0H
         MOV CL,04H
         ROL HR,CL
         CMP HR,CL
         CMP HR,09H
         JBE L5
         ADD HR,07H

     L5:
         ADD HR,30H
         MOV AH,02H
         MOV DL,HR
         INT 21H

         MOV DL,TEMP
         AND DL,0FH
         CMP DL,09H
         JBE L6

         ADD DL,07H
      L6:
         ADD DL,30H
         MOV AH,02H
         INT 21H
         RET
         DISPLAY ENDP                  ;DISPLAY PROCEDURE ENDS


CODE ENDS
END START






         


