ASSIGNMENT NO 13 ROLL NO:03 DIV B

;ABSTRACT : THIS TSR PROGRAM IS WRITTEN FOR SCREENSAVER WHICH DEFINES SCREENSAVER FOR 5 SECONDS.FOR IT THIS TSR 
;           PROGRAM SHOULD CAPTURE KEYBOARD INTERRUPT(INT 09H) AND TIMER INTERRUPT(INT 08H).WHEN KEYBOARD INTERRUPT IS 
;           GENERATED THIS PROGRAM CHECKS THE STATUS OF ACTIVE PAGE & ACCORDINGLY ACTIVATES SCREENSAVER. 
;           TIMER INTERRUPT 08H IS HARDWARE INTRRUPT THAT UPDATES SYSTEM TIME & DATE.A PROGRAMMABLE TIMER CHIOP GENERATES AN 
;           INTERRUPT EVERY 54.9 milliseconds.THEREFORE TIMER ROUTINE COUNTS THE TIMER TICKS AND WHEN SCREENSAVER TIME OF 5 SECONDS
;           IS COMPLETED IT DISPLAYS SCREENSAVER.
 


;TITLE : TSR PROGRAM FOR SCREEN SAVER USING INTERRUPTS 08(TIMER) & 09(KEYBOARD)

CODE SEGMENT
        ASSUME CS:CODE
        ORG 0100H                               ; .COM PROGRAM

START:
        JMP INITIALISE                          ; JUMP TO INITIALIZATION ROUTINE
        PREVKBD DD ?                            ; FOR SAVING OLD VECTOR OF 09H
        CNT DW 0                                ; COUNT = 0
        PREVTIMER DD ?                          ; FOR SAVING OLD VECTOR OF 08H
        TIME DW 91                              ; SET SCREEN SAVER TIME TO 5 SECONDS



        ACT DB 0                                ; ACTIVE PAGE STATUS
	SPEAKON DB 0
        MSG DB 10,13,"SCREEN SAVER TSR......!$" ; MESSAGE WHEN SCREEN SAVER NOT ACTIVE

KBD_ROUTINE:
       PUSH AX                                  ; SAVE REGISTERS
       PUSH BX
       PUSH CX
       PUSH DX
       PUSH DI
       PUSH SI

       PUSH DS
       PUSH ES
       PUSH SS
       PUSH SP
       PUSH BP
       PUSH CS
       POP DS                                   ; MAKE CS = DS

       MOV CNT,0                                ; INITIALIZE COUNT = 0
       MOV AH,ACT                               ; IF KEY IS PRESSED THEN CHECK ACTIVE PAGE STATUS
       CMP AH,0                                 ; IF NOT SCREEN SAVER PAGE GOTO FINISH1
       JE FINISH1
       MOV ACT,0                                ; IF KEY IS PRESSED WHEN SCREEN SAVER IS DISPLAYED

       MOV AH,05H                               ; DISPLAY ORIGINAL PAGE
       MOV AL,0                                 ; PAGE NUMBER
       INT 10H                   

FINISH1:
       POP  BP
       POP  SP
       POP  SS
       POP  ES
       POP  DS
       POP  SI
       POP  DI
       POP  DX
       POP  CX
       POP  BX
       POP  AX
       JMP DWORD PTR CS:PREVKBD

TIMER_ROUTINE:
       PUSH AX                                  ; SAVE REGISTERS
       PUSH BX
       PUSH CX
       PUSH DX
       PUSH DI
       PUSH SI


       PUSH DS
       PUSH ES
       PUSH SS
       PUSH SP
       PUSH BP
       PUSH CS                                  ; MAKE CS = DS               
       POP DS
       MOV AH,ACT                               ; CHECK STATUS OF ACTIVE PAGE
       CMP AH,1                                 ; IF SCREEN SAVER IS DISPLAYED THEN GOTO FINISH2
       JE FINISH2
       INC WORD PTR CNT                         ; IF NOT SCREEN SAVER INCREMENT COUNT TIME UP TO 5 SECONDS
       MOV AX,WORD PTR TIME
       CMP AX,WORD PTR CNT                      ; COMPARE TIME WITH 5 SECONDS
       JNE FINISH2                              ; IF TIME OF 5 SECONDS NOT MET THEN GOTO FINISH2

        MOV AH,02H                              ; TO SET SCREEN SAVER DISPLAY PAGE
        MOV BH,01H                              ; PAGE 1
        MOV DH,10H                              ; ROW Y CO-ORDINATE
        MOV DL,10H                             	; COL X CO-ORDINATE
	INT 10H


        MOV AH,09H    				; WRITE CHARACTER AND ATTRIBUTE AT CURSOR
        MOV AL,'A'
        MOV BH,1      				; PAGE 1
        MOV BL,0DAH   				; ATTRIBUTE BYTE
                      				; BACKGROUNG COLOR=MAGNETA & FOREGROUNG COLOR=CYAN
        MOV CX,50     				; REPLICATION FACTOR
	INT 10H

	MOV AH,05H
        MOV AL,1     				; ACTIVE PAGE1
	INT 10H

        MOV ACT,1     				; ACTIVE PAGE STATUS = 1
        MOV CNT,0     				; INITIALIZE TIMER COUNTER = 0
	
FINISH2:
       POP BP       				; RESTORE REGISTERS
       POP SP
       POP SS
       POP ES
       POP DS
       POP SI
       POP DI
       POP DX
       POP CX
       POP BX

	POP AX
        JMP DWORD PTR CS:PREVTIMER    		; RESUME OLD VECTOR OF TIMER

INITIALISE:
        
        
        CLI ; PREVENT INTERRUPTS

        MOV AH,35H      			; TO GET INT VECTOR ADDRESS OF 09H.
	MOV AL,09H      			; FOR KBD.
	INT 21H

	MOV WORD PTR PREVKBD+2,ES
	MOV WORD PTR PREVKBD,BX

        MOV AH,25H      			; SET VECTOR 09 TO KBD_ROUTINE
	MOV AL,09H
        MOV DX,OFFSET KBD_ROUTINE
	INT 21H

        MOV AH,35H       			; TO GET INT VECTOR ADDRESS OF 08H
	MOV AL,08H
	INT 21H
	MOV WORD PTR PREVTIMER+2,ES
	MOV WORD PTR PREVTIMER,BX

        MOV AH,25H      			; SET VECTOR 08 TO TIMER_ROUTINE
	MOV AL,08H
        MOV DX,OFFSET TIMER_ROUTINE
	INT 21H

        LEA DX,MSG       			; DISPLAY MESSAGE
	MOV AH,09H
	INT 21H

        MOV AH,31H       			; TERMINATE BUT STAY TESIDENT FUNCTION
        MOV DX,OFFSET INITIALISE       	 	; SET SIZE
        STI              			;RESTORE INTERRUPTS
	INT 21H

CODE ENDS
END START


